
#include <sys/time.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

#include <stdint.h>
#include "../therm_adm103x.h"


int main()
{
	IOC_Adm103x data;
	IOC_Adm103x datb;
	int fd,r;
	fd = open("/dev/adm103x", O_RDWR);
	if (fd == -1) {perror("open");return 1;}
	data.id = 0;
	printf("Reading : %d\n",data.id);
	r = ioctl(fd,ADM103X_IOC_GETTEMP,&data);
	if (r<0) perror("ioctl");
	printf("ADM103X_IOC_GETTEMP = %d\n",data.millitemp);
	
	r = ioctl(fd,ADM103X_IOC_GETLIMITS,&data);
	if (r<0) perror("ioctl");
	printf("ADM103X_IOC_GETLIMITS = %d %d\n",data.mintemp,data.rangetemp);
	
	r = ioctl(fd,ADM103X_IOC_GETMINPWM,&data);
	if (r<0) perror("ioctl");
	printf("ADM103X_IOC_GETMINPWM = %d\n",data.minpwm);
	
	r = ioctl(fd,ADM103X_IOC_GETHYSTERESIS,&data);
	if (r<0) perror("ioctl");
	printf("ADM103X_IOC_GETHYSTERESIS = %d\n",data.hysteresis);
	
	data.reg = 0x22;
	r = ioctl(fd,ADM103X_IOC_GETREGISTER,&data);
	if (r<0) perror("ioctl");
	printf("ADM103X_IOC_GETREG = %02X\n",data.value);


	printf("Press Enter");fflush(stdout);getchar();
	printf("Check Fan\n");
	r = ioctl(fd,ADM103X_IOC_CHECK_IF_FAN_IS_NEEDED,0);
	if (r<0) perror("ioctl");

#if 0
	printf("Press Enter");fflush(stdout);getchar();
	
	datb = data;
	datb.hysteresis = 3;
	datb.minpwm = 20;
	datb.mintemp = 60;
	datb.rangetemp = 10;
	datb.value = 0x08;
	printf("Setting\n");
	r = ioctl(fd,ADM103X_IOC_SETHYSTERESIS,&datb);
	if (r<0) perror("ioctl");
	r = ioctl(fd,ADM103X_IOC_SETLIMITS,&datb);
	if (r<0) perror("ioctl");
	r = ioctl(fd,ADM103X_IOC_SETREGISTER,&datb);
	if (r<0) perror("ioctl");
	r = ioctl(fd,ADM103X_IOC_SETHYSTERESIS,&datb);
	if (r<0) perror("ioctl");
	
	printf("Press Enter");fflush(stdout);getchar();
	printf("Resetting\n");
	r = ioctl(fd,ADM103X_IOC_SETHYSTERESIS,&data);
	if (r<0) perror("ioctl");
	r = ioctl(fd,ADM103X_IOC_SETLIMITS,&data);
	if (r<0) perror("ioctl");
	r = ioctl(fd,ADM103X_IOC_SETMINPWM,&data);
	if (r<0) perror("ioctl");
	r = ioctl(fd,ADM103X_IOC_SETHYSTERESIS,&data);
	if (r<0) perror("ioctl");
#endif	

	close(fd);
	return 0;
}



